/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
 /* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.graph;

import java.util.BitSet;
import java.util.Set;

import cn.ac.ios.value.ContextValue;
import cn.ac.ios.value.Value;

/**
 * An interface for general graph, modified from the IscasMC (http://iscasmc.ios.ac.cn/) by Ernst Moritz Hahn
 * */
public interface Graph {
	
	ModelType getModelType();
	
	ContextValue getContextValue();
	
	int getNumNodes();
	
	BitSet getInitialNodes();
	
	void queryNode(int node);
	
	int getQueriedNode();
	
	int getNumSuccessors();
	
	int getSuccessorNode(int succNr);
			
    Value getGraphProperty(Object property);
    
	Set<Object> getGraphProperties();
	
    NodeProperty getNodeProperty(Object property);

    Set<Object> getNodeProperties();
    
    EdgeProperty getEdgeProperty(Object property);

    Set<Object> getEdgeProperties();
}
