/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
 /* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.learner.multiplicity;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import cn.ac.ios.automata.words.Word;
import cn.ac.ios.query.MembershipOracle;
import cn.ac.ios.query.Query;

public class MembershipOracleImpl implements MembershipOracle<Double> {

	@Override
	public Double answerMembershipQuery(Query<Double> query) {
		Word queriedWord = query.getQueriedWord();
		System.out.println("What's the value of " + queriedWord.toStringWithAlphabet() + " in the target function:");
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		double answer = 0;
		boolean flag = false;
		while(!flag){
		try {
				String input = reader.readLine();
				answer = Double.parseDouble(input);
				flag = true;
			}
		 catch (Exception e) {
			e.printStackTrace();
			System.out.println("Illegal input, try again!");
		}
		}
		query.answerQuery(answer);
		return answer;
	}


	

}
